package xyz.pixelatedw.finalbeta.mixin;

import org.objectweb.asm.Opcodes;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.Slice;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.DrawableHelper;
import net.minecraft.client.gui.Overlay;
import net.minecraft.client.render.TextRenderer;
import xyz.pixelatedw.finalbeta.Direction;
import xyz.pixelatedw.finalbeta.ModConfig;
import xyz.pixelatedw.finalbeta.WyHelper;

@Mixin(Overlay.class)
public class OverlayMixin extends DrawableHelper {

	@Shadow
	private Minecraft minecraft;
	
	@Inject(
		method = "render(FZII)V", 
		at = @At(
			value = "INVOKE", 
			target = "Lorg/lwjgl/opengl/GL11;glPopMatrix()V",
			remap = false
		),
		slice = @Slice(
			from = @At(
				value = "INVOKE", 
				target = "Lnet/minecraft/client/gui/Overlay;drawTextWithShadow(Lnet/minecraft/client/render/TextRenderer;Ljava/lang/String;III)V"
			), 
			to = @At(
				value = "FIELD", 
				target = "Lnet/minecraft/client/gui/Overlay;jukeboxMessageTime:I",
				opcode = Opcodes.GETFIELD
			)
		)
	)
	public void render(float f, boolean flag, int i, int j, CallbackInfo ci) {
		TextRenderer textRenderer = this.minecraft.textRenderer;
		this.drawTextWithShadow(textRenderer, "(" + Direction.fromEntity(this.minecraft.player).toString() + ")", 23, 88, 14737632);
		if (ModConfig.ENABLE_TIME_TRACKING.get()) {
			this.drawTextWithShadow(textRenderer, "Play Time: " + WyHelper.getGameDaysPlayed() + " (" + WyHelper.getRealDaysPlayed() + ")", 2, 96, 14737632);
		}
	}
}
